import Events from 'events';

const createEmitter = () => {
    let Emitter_ = new Events.EventEmitter();
    Emitter_.setMaxListeners(100);
    return Emitter_;
}


const genEvent = (eventID, emitter) => {
    return (handler, once = false) => {
        let safeHandler = (...args) => {
            try {
                handler(...args);
            } catch (ex) {
                console.error(ex);
            }
        };
        let handleWrap = safeHandler;
        if (once) {
            handleWrap = (...args) => {
                emitter.removeListener(eventID, handleWrap);
                safeHandler(...args);
            };
        }

        emitter.addListener(eventID, handleWrap);
        // console.log(emitter._events);
        return () => emitter.removeListener(eventID, handleWrap);
    };
}

export {
    genEvent,
    createEmitter
};