const path = require('path');
const HtmlWebpackPlugin = require("html-webpack-plugin");

module.exports = {
  entry: {
    'index': './index.js'
  },
  output: {
    path: path.join(__dirname, './dist'),
    filename: '[name].js',
    library: "Meoser",
    libraryTarget: "umd"
  },
  module: {
    rules: [{
      test: /\.jsx?$/,
      loader: 'babel-loader',
      query: {
        plugins: ['transform-runtime'],
        presets: ['es2015', 'stage-0']
      },
      exclude: /node_modules/
    },
    { test: /\.json$/,
      loader: 'json-loader'
    }]
  },
  plugins: [
    new HtmlWebpackPlugin({
        template: "./index.ejs"
    })
  ],
  mode: "production",
  devtool: "cheap-module-source-map"
}